1
+#!/usr/bin/env bash
2
+#
3
+# Unit-testing script
4
+#
5
+# This script does the following:
6
+# 1. Check whether any files were modified that would necessitate unit testing (using the `TRAVIS_COMMIT_RANGE` environment variable).
7
+# 2. If there are no changed files that require unit testing, exit successfully.
8
+# 3. Otherwise, run all the unit tests.
9
+#
10
+# We do things this way because our unit testing takes a rather long
11
+# time (average 18-19 minutes as of the original creation of this script),
12
+# so skipping it when we don't actually need it can significantly speed
13
+# up the CI process.
14
+#
15
+# Copyright: SPDX-License-Identifier: GPL-3.0-or-later
16
+#
17
+# Author: Austin S. Hemmelgarn <austin@netdata.cloud>
18
+#
19
+# shellcheck disable=SC2230
20
+
21
+install_netdata() {
22
+ echo "Installing Netdata"
23
+ fakeroot ./netdata-installer.sh --install $HOME --dont-wait --dont-start-it --enable-plugin-nfacct --enable-plugin-freeipmi --disable-lto
24
+}
25
+
26
+c_unit_tests() {
27
+ echo "Running C code unit tests"
28
+ $HOME/netdata/usr/sbin/netdata -W unittest
29
+}
30
+
31
+run_c_unit_tests=
32
+
33
+if [ -z ${TRAVIS_COMMIT_RANGE} ] ; then
34
+ # Travis gave us no commit range, so just run all the unit tests.
35
+ # Per the docs, this is the case when a new branch is pushed for the first time.
36
+ echo "No commit range supplied, assuming the worst case and running all unit tests."
37
+ run_c_unit_tests=1
38
+else
39
+ changed_paths=
40
+
41
+ if [ "${TRAVIS_PULL_REQUEST}" = "false" ] ; then
42
+ # This is not a PR build.
43
+ COMMIT1="$(echo ${TRAVIS_COMMIT_RANGE} | cut -f 1 -d '.')"
44
+ COMMIT2="$(echo ${TRAVIS_COMMIT_RANGE} | cut -f 4 -d '.')"
45
+
46
+ if [ "$(git cat-file -t ${COMMIT1} 2>/dev/null)" = commit -a "$(git cat-file -t ${COMMIT2} 2>/dev/null)" = commit ] ; then
47
+ # Examine the exact set of commits passed by Travis.
48
+ echo "Checking commits:"
49
+ git log --format=oneline --abbrev-commit ${COMMIT1}..${COMMIT2}
50
+ changed_paths="$(git diff --name-only ${COMMIT1}..${COMMIT2} --)"
51
+ else
52
+ # We couldn't find at least one of the changesets, so this build
53
+ # was probably triggered by a history rewrite. Since we can't
54
+ # figure out what chnaged, we need to just run all the tests anyway.
55
+ echo "Cannot determine which commits we are testing, running all unit tests."
56
+ run_c_unit_tests=1
57
+ fi
58
+ else
59
+ # This is a PR build, look at all commits from the target branch
60
+ # to HEAD.
61
+ echo "Checking commits:"
62
+ git log --format=oneline --abbrev-commit ${TRAVIS_BRANCH}..HEAD
63
+ changed_paths="$(git diff --name-only ${TRAVIS_BRANCH}..HEAD --)"
64
+ fi
65
+
66
+ if [ -n "${changed_paths}" ] ; then
67
+ # Check for changes that would require the C code to be re-tested
68
+ if (echo ${changed_paths} | grep -qE "daemon/unit_test|database") ; then
69
+ echo "Commits appear to change C code with unit tests, queueing C unit tests."
70
+ run_c_unit_tests=1
71
+ fi
72
+ fi
73
+fi
74
+
75
+if [ -z ${run_c_unit_tests} ] ; then
76
+ # No tests to run, log this and exit with success
77
+ echo "Commit range ${TRAVIS_COMMIT_RANGE} appears to make no changes that require unit tests, skipping unit testing."
78
+ exit 0
79
+else
80
+ install_netdata || exit 1
81
+
82
+ if [ -n ${run_c_unit_tests} ] ; then
83
+ c_unit_tests || exit 1
84
+ fi
85
+fi